#ifndef CODEHIGHLIGHTER_H
#define CODEHIGHLIGHTER_H

#include <QSyntaxHighlighter>

class CodeHighlighter : public QSyntaxHighlighter
{
	Q_OBJECT

public:
	explicit CodeHighlighter( QTextDocument *pParent = 0 );
	
private:
	void highlightBlock( const QString &pText );

	struct HighlightingRule
	{
		QRegExp pattern;
		QTextCharFormat format;
	};

	QVector<HighlightingRule> highlightingRules;

	QRegExp commentStartExpression;
	QRegExp commentEndExpression;

	QTextCharFormat keywordFormat;
	QTextCharFormat classFormat;
	QTextCharFormat singleLineCommentFormat;
	QTextCharFormat multiLineCommentFormat;
	QTextCharFormat quotationFormat;
	QTextCharFormat functionFormat;

signals:
	
public slots:
	
};

#endif // CODEHIGHLIGHTER_H
