#include "mooapp.h"
#include "mainwindow.h"
#include "connectionmanager.h"
#include "connection.h"
#include "listener.h"
#include "taskentry.h"
#include <QApplication>

int main( int argc, char *argv[] )
{
	QApplication	a( argc, argv );
	mooApp			m;
	Listener		l( 0 );
	MainWindow		w;
	ConnectionId	cid = ConnectionManager::instance()->doConnect( 0 );
	Connection		*c = ConnectionManager::instance()->connection( cid );

	QObject::connect( &w, SIGNAL(textCommand(QString)), c, SLOT(dataInput(QString)) );
	QObject::connect( c, SIGNAL(taskOutput(TaskEntry&)), &m, SLOT(doTask(TaskEntry&)) );

	QObject::connect( &m, SIGNAL(textOutput(QString)), &w, SLOT(textOutput(QString)) );
	QObject::connect( c, SIGNAL(textOutput(QString)), &w, SLOT(textOutput(QString)) );

	w.show();

	return a.exec();
}
