#ifndef VERBEDITOR_H
#define VERBEDITOR_H

#include <QWidget>
#include <QCloseEvent>

#include "object.h"
#include "codehighlighter.h"

namespace Ui
{
    class VerbEditor;
}

class VerbEditor : public QWidget
{
    Q_OBJECT

public:
	explicit VerbEditor( QWidget *parent = 0, Object *pObject = 0, const QString &pVerbName = "", Verb *pVerb = 0 );
	virtual ~VerbEditor();

private slots:
    void compile( void );
    void changed( void );
    void save( void );

	void closeEvent( QCloseEvent *pEvent );

private:
    Ui::VerbEditor		*ui;
	CodeHighlighter		*mHighlighter;
    Object				*mObject;
    QString				 mVerbName;
	Verb				*mVerb;
};

#endif // VERBEDITOR_H
