#ifndef LISTENER_H
#define LISTENER_H

#include "mooglobal.h"
#include <QObject>
#include <QTcpServer>
#include <QTcpSocket>
#include "connection.h"

class ListenerSocket : public QObject
{
	Q_OBJECT

public:
	explicit ListenerSocket( QObject *pParent, QTcpSocket *pSocket );

private slots:
	void disconnected( void );
	void readyRead( void );
	void textInput( const QString &pText );

signals:
	void textOutput( const QString &pText );

private:
	ConnectionId	 mConnectionId;
	QTcpSocket		*mSocket;
	QString			 mBuffer;
};

class Listener : public QObject
{
    Q_OBJECT

public:
	explicit Listener( ObjectId pObjectId, QObject *parent = 0 );

	virtual ~Listener( void );

	inline ObjectId objectid( void ) const
	{
		return( mObjectId );
	}

private slots:
	void newConnection( void );

private:
	ObjectId				mObjectId;
	QTcpServer				mServer;
	ObjectId				mListeningObjectId;
};

#endif // LISTENER_H
