#include <QDateTime>
#include "mooapp.h"
#include "object.h"
#include "objectmanager.h"
#include "connectionmanager.h"
#include "task.h"
#include "connection.h"
#include "lua_moo.h"
#include "lua_object.h"
#include "lua_connection.h"
#include "lua_prop.h"
#include "lua_verb.h"
#include "lua_task.h"
#include <iostream>
#include <algorithm>

mooApp::mooApp( QObject *pParent )
	: QObject( pParent ), mTimerId( 0 )
{
	connect( this, SIGNAL(destroyed(QObject*)), this, SLOT(cleanup(QObject*)));

	ObjectManager		&OM = *ObjectManager::instance();
	//ConnectionManager	&CM = *ConnectionManager::instance();

	OM.load();

	lua_moo::initialiseAll();

	//qint64				 TimeStamp = QDateTime::currentMSecsSinceEpoch();

	if( ObjectManager::instance()->maxId() == 0 )
	{
		ObjectManager::instance()->luaMinimal();
	}

//	Task				 Tsk;
//	lua_task			 Com( 0, Tsk );

//	Com.execute( pTimeStamp );

	if( ObjectManager::instance()->object( 0 ) != 0 )
	{
		QString			 CMD = QString( "moo.root:server_started()" );
		TaskEntry		 TE( CMD, 0, 0 );
		lua_task		 Com( 0, TE );

		Com.eval();
	}

	if( true )
	{
//		Connection		 Con;

//		lua_task		 Com( &Con, "" );

//		Com.execute( QDateTime::currentMSecsSinceEpoch() );
	}

	mTimerId = startTimer( 40 );
}

void mooApp::cleanup( QObject *pObject )
{
}

mooApp::~mooApp()
{
	if( mTimerId == 0 )
	{
		killTimer( mTimerId );
	}

	ObjectManager::instance()->save();

	ObjectManager::instance()->reset();
}

void mooApp::doOutput( const QString &pText )
{
	emit textOutput( pText );
}

void mooApp::streamCallback( const QString &pText, void *pUserData )
{
	((mooApp*)pUserData)->doOutput( pText );
}

void mooApp::timerEvent( QTimerEvent *pEvent )
{
	ObjectManager::instance()->onFrame( QDateTime::currentMSecsSinceEpoch() );
}

void mooApp::doTask( TaskEntry &pTask )
{
	ObjectManager::instance()->doTask( pTask );
}

